--- old/usr/src/common/list/list.c	2015-08-17 21:08:02.937878979 +0300
+++ new/usr/src/common/list/list.c	2015-08-17 21:08:02.945565575 +0300
@@ -75,6 +75,7 @@
 
 	list->list_size = size;
 	list->list_offset = offset;
+	list->list_numnodes = 0;
 	list->list_head.list_next = list->list_head.list_prev =
 	    &list->list_head;
 }
@@ -88,6 +89,7 @@
 	ASSERT(list->list_head.list_next == node);
 	ASSERT(list->list_head.list_prev == node);
 
+	list->list_numnodes = 0;
 	node->list_next = node->list_prev = NULL;
 }
 
@@ -117,6 +119,7 @@
 list_insert_head(list_t *list, void *object)
 {
 	list_node_t *lold = &list->list_head;
+	list->list_numnodes++;
 	list_insert_after_node(list, lold, object);
 }
 
@@ -124,6 +127,7 @@
 list_insert_tail(list_t *list, void *object)
 {
 	list_node_t *lold = &list->list_head;
+	list->list_numnodes++;
 	list_insert_before_node(list, lold, object);
 }
 
@@ -133,6 +137,7 @@
 	list_node_t *lold = list_d2l(list, object);
 	ASSERT(!list_empty(list));
 	ASSERT(lold->list_next != NULL);
+	list->list_numnodes--;
 	list_remove_node(lold);
 }
 
@@ -142,6 +147,7 @@
 	list_node_t *head = list->list_head.list_next;
 	if (head == &list->list_head)
 		return (NULL);
+	list->list_numnodes--;
 	list_remove_node(head);
 	return (list_object(list, head));
 }
@@ -152,6 +158,7 @@
 	list_node_t *tail = list->list_head.list_prev;
 	if (tail == &list->list_head)
 		return (NULL);
+	list->list_numnodes--;
 	list_remove_node(tail);
 	return (list_object(list, tail));
 }
@@ -209,12 +216,14 @@
 	if (list_empty(src))
 		return;
 
+	dst->list_numnodes += src->list_numnodes;
 	dstnode->list_prev->list_next = srcnode->list_next;
 	srcnode->list_next->list_prev = dstnode->list_prev;
 	dstnode->list_prev = srcnode->list_prev;
 	srcnode->list_prev->list_next = dstnode;
 
 	/* empty src list */
+	src->list_numnodes = 0;
 	srcnode->list_next = srcnode->list_prev = srcnode;
 }
 
@@ -249,3 +258,20 @@
 {
 	return (list_empty(list));
 }
+
+ulong_t
+list_numnodes(list_t *list)
+{
+	/*
+	size_t sz = 0;
+	list_node_t *node;
+
+	node = &list->list_head;
+	while (node->list_next != &list->list_head) {
+		sz++;
+		node = node->list_next;
+	}
+	return (sz);
+	*/
+	return (list->list_numnodes);
+}
